package oop4_dat4_u;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 *
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 */
public class ButtonListener implements ActionListener
{

    private Calculator gui;

    public ButtonListener(Calculator gui)
    {
        this.gui = gui;
    }

    public void actionPerformed(ActionEvent e)
    {
        // operator: 0=Unbekannt, 1=Plus, 2=Minus, 3=Multiplikation, 4=Division

        //erstes Zeichen der Button Beschriftung
        char ch = (e.getActionCommand()).charAt(0); 
        switch (ch) {
            // + - * /
            case '+':
                gui.operator = 1;
                break;
            case '-':
                gui.operator = 2;
                break;
            case '*':
                gui.operator = 3;
                break;
            case '/':
                gui.operator = 4;
                break;

            //rechnen...
            case '=':
                switch (gui.operator) {
                    case 1: // Plus
                        gui.result = gui.operand1 + gui.operand2;
                        break;
                    case 2: // Minus
                        gui.result = gui.operand1 - gui.operand2;
                        break;
                    case 3: // Multiplikation
                        gui.result = gui.operand1 * gui.operand2;
                        break;
                    case 4: // Division
                        gui.result = gui.operand1 / gui.operand2;
                        break;
                    case 0: // unbekannt
                        gui.result = gui.operand1;
                        break;
                }
                // ausgeben
                gui.operand1 = gui.result;
                gui.operand2 = 0;
                gui.operator = 0;
                gui.display.setText("" + gui.result); // convert int auf String
                break;

            // Clear
            case 'C':
                gui.result = 0;
                gui.operand1 = 0;
                gui.operand2 = 0;
                gui.operator = 0;
                gui.display.setText("0");
                break;

            // Sign
            case 'S':
                if (gui.operator == 0) {
                    gui.operand1 *= -1;
                    gui.display.setText("" + gui.operand1);

                } else {
                    gui.operand2 *= -1;
                    gui.display.setText("" + gui.operand2);
                }
                break;

            // default, Zahlen
            default:
                int digit = ch - '0'; // int wert "bestimmen" von Char
                if (gui.operator == 0) {
                    gui.operand1 = (gui.operand1 * 10) + digit;
                    gui.display.setText("" + gui.operand1);
                } else {
                    gui.operand2 = (gui.operand2 * 10) + digit;
                    gui.display.setText("" + gui.operand2);
                }
                break;
        }
    }
}
